/* libiso8601/src/libiso8601/manip.c
 *
 *  (c)2006, Laurence Withers, <l@lwithers.me.uk>.
 *  Released under the GNU GPLv2. See file COPYING or
 *  http://www.gnu.org/copyleft/gpl.html for details.
*/



void iso8601_add_seconds(struct iso8601_date* date, long seconds)
{
    ldiv_t qr;

    switch(date->sec) {
    case 86400:
    case 86401:
        --date->sec; 
        break;
    }
    
    qr = ldiv(seconds + date->sec, 86400);
    date->day += qr.quot;
    date->sec = qr.rem;
    if(date->sec < 0) {
        --date->day;
        date->sec += 86400;
    }
}



/* options for text editors
kate: replace-trailing-space-save true; space-indent true; tab-width 4;
vim: expandtab:ts=4:sw=4
*/
